#include "DrawField.h"

#include <QPainter>
#include <QtGui>
#include <iostream>

CDrawField::CDrawField(QWidget *parent)
:QWidget(parent){
	//setBackgroundRole(QPalette::Base);
	setPalette(QPalette(QColor(250, 250, 200)));
	setAutoFillBackground(true);
	flag = false;
        rate=150;

}


void CDrawField::zoomIn()
{
	rate += 10;	
	repaint();
}

void CDrawField::zoomOut()
{
	rate -= 10;
	repaint();
}

void CDrawField::drawSpot(data_list_t *list, int counter_){
	flag = true;
	p_list = list;
        counter=counter_;
	repaint();

}

void CDrawField::paintEvent(QPaintEvent * )
{
	if(flag){
                QPainter p(this);

                for(int ip=0; ip < counter; ip++){
                        p.setPen(QPen(QColor(250, 50, 50), 4));
                        p.drawPoint(p_list[ip].xp[0]*rate + 400, p_list[ip].yp[0]*rate + 400);

                        p.setPen(QPen(QColor(50, 250, 50), 4));
                        p.drawPoint(p_list[ip].xp[1]*rate + 400, p_list[ip].yp[1]*rate + 400);

                        p.setPen(QPen(QColor(50, 50, 250), 4));
                        p.drawPoint(p_list[ip].xp[2]*rate + 400, p_list[ip].yp[2]*rate + 400);
			//cout << "xp=" << itr->x() << ",yp=" << itr->y() << endl;	
		}
			
		flag = true;
	}
}
