#include <QtGui>
#include "three_bodycalc.h"
#include "CalcWindow.h"

int main(int argc, char *argv[]){
	QApplication app(argc, argv);
	CalcWindow win;
        CThreeBodyEuler eeuler;
        CThreeBodyRK2 erk2;
        CThreeBodyRK4 erk4;
	
	//GUIコンポーネントにシミレーションエンジンを接続
        win.getParPanel()->setSimEngine(&eeuler, &erk2, &erk4);
	
	//パラメターの初期設定を行う
        erk2.setParam(2.0e0, 1.0e0);
	win.getParPanel()->updateParam();

        erk2.Calculation();
	win.getParPanel()->updateAMInfo();
        win.getDrawField()->drawSpot(CCalcEngine::getList(), CCalcEngine::getCounter());
	
	win.show();
	return app.exec();
}
