#ifndef CALC_TEMPLATE_H
#define CALC_TEMPLATE_H

#include <list>
#include<iostream>
#include<qpoint.h>

using namespace std;

typedef struct DATA_LIST
{
    double xp[3], yp[3];
     double ag[3];

}data_list_t;

typedef struct Anguler_Momentum_LIST
{
        double am[4];
}am_list_t;

class CCalcEngine{
public:
	CCalcEngine();
	~CCalcEngine(){}
	virtual void Calculation(){}
        static data_list_t* getList(){
                return data_list;
	}
	
        static am_list_t* getAMList(){
                return &am_list;
	}	
	
        static int getCounter(){
            return count;
        }

        static void setParam(double xp3, double factor);
	
        static double Xp3(){
		return xp[2];
	}

	
        static double Factor(){
		return factor;
	}

        static int NStep(){
            return nstep;
        }

        static void NStep(int stepNum){
            nstep=stepNum;
        }

protected:
	void CalcStDeviation();
	
protected:
        static int maxtime, nstep, count;
        static double dtmin, dt, time;
	double end_time;
        static double xp[3],yp[3],vx[3],vy[3], mp[3], xg, yg, vxg, vyg, vp;
        static am_list_t am_list;
        static double factor;
        const double PI_;
        static data_list_t data_list[10000];

};


class CThreeBodyEuler : public CCalcEngine{
public:
	CThreeBodyEuler();
	~CThreeBodyEuler();
	void Calculation();
};

class CThreeBodyRK2 : public CCalcEngine{
public:
        CThreeBodyRK2();
        ~CThreeBodyRK2();
        void Calculation();
};

class CThreeBodyRK4 : public CCalcEngine{
public:
        CThreeBodyRK4();
        ~CThreeBodyRK4();
        void Calculation();
};

#endif
